<template>
    <!-- 数据分类管理 -->
    <div class="app-container">
        <TableModel :formLabel="formLabel" :showOperation="true" :showRightTools="true" ref="encryTypeTableRef"
            :columnsList="columnsList" :request-api="getEncryTypeListAPI">
            <template slot="btn">
                <el-button plain size="mini" type="primary" icon="el-icon-plus" v-hasPermi="['encry:type:add']"
                    @click="handleAdd">
                    新增
                </el-button>
            </template>

            <template slot="handle" slot-scope="{ data }">
              <el-button plain size="mini" type="primary" icon="el-icon-edit" v-hasPermi="['encry:type:list']"
                         @click="handleDetail(data)">
                详情
              </el-button>
                <el-button plain size="mini" type="primary" icon="el-icon-edit" v-hasPermi="['encry:type:edit']"
                    @click="handleUpdate(data)">
                    修改
                </el-button>
                <el-button plain size="mini" type="danger" icon="el-icon-delete" v-hasPermi="['encry:type:del']"
                    @click="handleDelete(data)">
                    删除
                </el-button>
            </template>
        </TableModel>
        <!-- 新增/编辑 -->
        <EncryptionForm v-if="isflag" :isAdd="isAdd" :rowData="row" @handleQuery="handleQuery" :title="title"
            @closeDialog="closeDialog" @showColose="showColose" :dataForm="row" :disabled="isAdd === 'detail'" :width="600" />
    </div>
</template>

<script>
import TableModel from '@/components/TableModel'
import { columnsList, formLabel } from './config'
import {
    deleteEncryTypeAPI,
    getEncryTypeListAPI,
} from '@/api/filesTransfer/encryption'
import EncryptionForm from './prop/encryptionForm'


export default {
    name: 'Encryption',
    components: {
        TableModel,
        EncryptionForm
    },
    data() {
        return {
            formLabel,
            columnsList,
            getEncryTypeListAPI,
            title: "",
            isflag: false,
            isAdd: '',
            row: {},
            loading: false,
        }
    },

    created() {

    },

    methods: {
      /** 详情操作 */
      handleDetail(row) {
        this.title = "详情";
        this.isAdd = 'detail'; // 标记为详情模式
        this.row = row;
        this.isflag = true;
      },
        /** 新增按钮操作 */
        handleAdd() {
            this.title = "新增";
            this.isAdd = 'add';
            this.isflag = true;
        },
        closeDialog() {
            this.isflag = false;
        },
        showColose() {
            this.isflag = false;
        },
        /** 修改操作 */
        handleUpdate(row) {
            this.title = "修改";
            this.isAdd = 'edit';
            this.row = row;
            this.isflag = true;
        },
        /* 搜索操作 */
        handleQuery() {
            this.$refs.encryTypeTableRef.getTableList()
        },
        /** 删除操作 */
        handleDelete(row) {
            this.$modal.confirm(`是否确认删除档案加密名称为"${row.encryptName}"的数据项？`).then(() => {
                // 显示加载遮罩
                this.$modal.loading("正在删除，请稍候...");
                deleteEncryTypeAPI({ id: row.id }).then(res => {
                    this.$modal.closeLoading();
                    if (res.code === 200) {
                        this.$modal.msgSuccess("删除成功");
                        this.handleQuery();
                    } else {
                        this.$modal.msgError(res.msg);
                    }
                }).catch(error => {
                    this.$modal.closeLoading();
                    this.$modal.msgError(error);
                });
            }).catch(() => {
                // 用户取消删除，不需要处理
            });
        },
    },
}
</script>
